<?php

// $Id: google_keyhaviour.admin.inc,v 1.1.2.1 2009/04/10 04:28:03 danielb Exp $



/**

 * @file

 * The google_keyhaviour admin screens.

 */





/**

 * Admin google_keyhaviour list page.

 */

function google_keyhaviour_admin_list() {

  $output = '';

  $google_keyhaviours = google_keyhaviour_load_multiple();

  if (!$google_keyhaviours) {

    $output .= t('There are currently no google keyhaviour rules configured.');

  }

  else {

    $output .= drupal_get_form('google_keyhaviour_admin_list_form', $google_keyhaviours);

  }

  $output .= drupal_get_form('google_keyhaviour_admin_add_form');

  return $output;

}



/**

 * Admin google_keyhaviour list form.

 */

function google_keyhaviour_admin_list_form($form_state, $google_keyhaviours) {

  $form = array();

  $form['#tree'] = TRUE;

  $form['rules'] = array(

    '#title' => t('Google keyhaviour rules'),

    '#heading' => t('Rule'),

    '#weight' => 200,

    '#theme' => 'google_keyhaviour_admin_edit_table',

    '#description' => t('These actions let you manipulate template variables'),

  );

  foreach ((array)$google_keyhaviours as $google_keyhaviour) {

    $rule_output = "<div class='google_keyhaviour-rule'>";

    $rule_output .= check_plain($google_keyhaviour->settings['title']);

    $rule_output .= "</div>";

    $form['rules'][$google_keyhaviour->google_keyhaviour_id]['value']['#value'] = $rule_output;

    $form['rules'][$google_keyhaviour->google_keyhaviour_id]['ops']['#value'] =

      l('Edit', 'admin/build/google_keyhaviour/'. $google_keyhaviour->google_keyhaviour_id .'/edit')

            . t(" | ") . l('Delete', 'admin/build/google_keyhaviour/'. $google_keyhaviour->google_keyhaviour_id .'/delete');

    $form['rules'][$google_keyhaviour->google_keyhaviour_id]['weight'] = array(

      '#type' => 'weight',

      '#delta' => count($google_keyhaviours),

      '#default_value' => $google_keyhaviour->weight,

    );

  }

  $form['submit'] = array(

    '#type' => 'submit',

    '#value' => t('Save google keyhaviour rules order'),

    '#weight' => 10010,

  );

  return $form;

}



/**

 * Submit function for admin google_keyhaviour list form.

 */

function google_keyhaviour_admin_list_form_submit($form, &$form_state) {

  $values = &$form_state['values'];

  dsm($values);

  if (is_array($values['rules'])) {

    foreach ($values['rules'] as $google_keyhaviour_id => $value) {

      $google_keyhaviour = (object)array(

        'google_keyhaviour_id' => $google_keyhaviour_id,

        'weight' => $value['weight'],

      );

      $google_keyhaviour = google_keyhaviour_save($google_keyhaviour);

    }

  }

}



/**

 * Admin google_keyhaviour add form.

 */

function google_keyhaviour_admin_add_form($form_state) {

  $form = array();

  $form['submit'] = array(

    '#type' => 'submit',

    '#value' => t('Add google keyhaviour rule'),

    '#weight' => 22,

  );

  return $form;

}



/**

 * Submit function for admin google_keyhaviour add form.

 */

function google_keyhaviour_admin_add_form_submit($form, &$form_state) {

  $values = &$form_state['values'];

  $google_keyhaviour = (object)array('settings' => array());

  $google_keyhaviour = google_keyhaviour_save($google_keyhaviour);

  $google_keyhaviour->settings = array(

    'title' => t('Rule !id', array('!id' => $google_keyhaviour->google_keyhaviour_id)),

  );

  $google_keyhaviour = google_keyhaviour_save($google_keyhaviour);

  drupal_set_message('A google keyhaviour rule was added.  Configure the google keyhaviour rule below.');

  drupal_goto('admin/build/google_keyhaviour/'. $google_keyhaviour->google_keyhaviour_id .'/edit');

}



/**

 * Admin google_keyhaviour edit page.

 */

function google_keyhaviour_admin_edit($form_state, $google_keyhaviour) {

  global $custom_theme;



  // If non-default theme configuration has been selected, set the custom theme.

  $custom_theme = isset($theme) ? $theme : variable_get('theme_default', 'garland');



  // Fetch and sort blocks

  module_load_include('inc', 'block', 'block.admin');

  $blocks = _block_rehash();

  usort($blocks, '_block_compare');





  $form_state['storage']['google_keyhaviour'] = $google_keyhaviour;

  $settings = &$google_keyhaviour->settings;



  // build the form

  $form = array();

  $form['#tree'] = TRUE;

  $form['google_keyhaviour_id'] = array(

    '#type' => 'value',

    '#value' => $google_keyhaviour->google_keyhaviour_id ? $google_keyhaviour->google_keyhaviour_id : 'add',

    '#weight' => 0,

  );

  $form['settings'] = array(

    '#weight' => 60,

  );



  $form['settings']['title'] = array(

    '#type' => 'textfield',

    '#title' => t('Title'),

    '#default_value' => $settings['title'],

    '#size' => 40,

    '#maxlength' => 255,

    '#required' => TRUE,

    '#weight' => 20,

  );





  $form['settings']['conditions'] = array(

    '#weight' => 60,

    '#title' => t('Conditions'),

    '#type' => 'fieldset',

    '#description' => t('Save this page to add more conditions.'),

  );



  $form['settings']['conditions']['operator'] = array(

    '#type' => 'radios',

    '#title' => t('Conditions operator'),

    '#default_value' => $settings['conditions']['operator'] ? $settings['conditions']['operator'] : '&&',

    '#options' => array(

      '&&' => t('<b>and</b> - all conditions must be met'),

      '||' => t('<b>or</b> - any condition can be met'),

    ),

    '#weight' => 0,

  );

  unset($settings['conditions']['operator']);



  $settings['conditions'][] = array(

    'match' => '',

    'phrase' => '',

  );



  foreach ($settings['conditions'] as $key => $condition) {

    $form['settings']['conditions'][$key] = array(

      '#type' => 'fieldset',

    );

    $form['settings']['conditions'][$key]['match'] = array(

      '#type' => 'select',

      '#prefix' => '<span class="prefix">'. t('The google keywords') .'</span>',

      '#default_value' => $condition['match'],

      '#options' => array(

        '' => '',

        'contain' => t('contain the following phrase:'),

        'do not contain' => t('do not contain the following phrase:'),

        'are exactly' => t('are exactly the following phrase:'),

        'exist' => t('exist (no need to add a phrase)'),

      ),

    );

    $form['settings']['conditions'][$key]['phrase'] = array(

      '#type' => 'textfield',

      '#default_value' => $condition['phrase'],

    );

  }



  $form['settings']['blocks'] = array(

    '#weight' => 70,

    '#title' => t('Block visibility'),

    '#type' => 'fieldset',

    '#collapsible' => TRUE,

    '#collapsed' => $block_collapse,

  );



  $form['settings']['blocks']['visibility'] = array(

    '#type' => 'radios',

    '#weight' => 0,

    '#default_value' => $settings['blocks']['visibility'] ? $settings['blocks']['visibility'] : 'show',

    '#options' => array (

      'show' => t('Show all blocks'),

      'hide' => t('Hide all blocks'),

    ),

  );



  $block_options = array();

  foreach ($blocks as $i => $block) {

    if ($block['region'] != -1) { // hide disabled blocks

      $block_options[$block['bid']] = $block['info'] .' ('. google_keyhaviour_to_display($block['region']) .')';

    }

  }



  $form['settings']['blocks']['exceptions'] = array(

    '#type' => 'checkboxes',

    '#title' => t('Except for these'),

    '#weight' => 2,

    '#default_value' => $settings['blocks']['exceptions'] ? $settings['blocks']['exceptions'] : array(),

    '#options' => $block_options,

  );



  if (!empty($google_keyhaviour->actions)) {

    $form['actions'] = array(

      '#title' => t('Actions'),

      '#heading' => t('Action'),

      '#weight' => 200,

      '#theme' => 'google_keyhaviour_admin_edit_table',

      '#description' => t('These actions let you manipulate template variables'),

    );

    foreach ($google_keyhaviour->actions as $key => $value) {

      $action_output = "<div class='google_keyhaviour-action'>";

      $action_output .= "<span class='google_keyhaviour-action-verb'>". google_keyhaviour_to_display($value->settings['verb']) ."</span><span class='space'> </span>";

      $action_output .= "<span class='google_keyhaviour-action-var'>". google_keyhaviour_admin_list_variables($value->settings['var']) ."</span>";

      $action_output .= "<span class='google_keyhaviour-action-with'><span class='with-prefix'> with </span>". $value->settings['with'] ."</span>";

      $action_output .= "</div>";

      $form['actions'][$value->google_keyhaviour_action_id]['value']['#value'] = $action_output;

      $form['actions'][$value->google_keyhaviour_action_id]['ops']['#value'] =

        l('Edit', 'admin/build/google_keyhaviour/'. $google_keyhaviour->google_keyhaviour_id .'/edit/'. $value->google_keyhaviour_action_id .'/edit')

          . t(" | ") . l('Delete', 'admin/build/google_keyhaviour/'. $google_keyhaviour->google_keyhaviour_id .'/edit/'. $value->google_keyhaviour_action_id .'/delete');

      $form['actions'][$value->google_keyhaviour_action_id]['weight'] = array(

        '#type' => 'weight',

        '#delta' => count($google_keyhaviour->actions),

        '#default_value' => $key,

      );

    }

  }

  else {

    $form['no_actions'] = array(

      '#value' => t('

        <div id="edit-no-actions-wrapper" class="form-item">

        <label for="edit-path">Actions:</label>

        There are currently no actions configured for this google keyhaviour rule.

        </div>

      '),

      '#weight' => 100,

    );

  }



  $form['addaction'] = array(

    '#type' => 'submit',

    '#value' => t('Add google keyhaviour action'),

    '#weight' => 10001,

    '#prefix' => '<div>',

    '#suffix' => '</div>',

  );



  $form['submit'] = array(

    '#type' => 'submit',

    '#value' => t('Save google keyhaviour rule'),

    '#weight' => 10010,

  );

  $form['delete'] = array(

    '#type' => 'submit',

    '#value' => t('Delete google keyhaviour rule'),

    '#weight' => 10020,

  );

  return $form;

}



/**

 * Submit function for admin google_keyhaviour add/edit page.

 */

function google_keyhaviour_admin_edit_submit($form, &$form_state) {

  $values = &$form_state['values'];

  if ($form_state['clicked_button']['#id'] == 'edit-delete') {

    drupal_goto('admin/build/google_keyhaviour/'. $values['google_keyhaviour_id'] .'/delete');

  }

  else {

    // remove blank conditions

    foreach ($values['settings']['conditions'] as $key => $value) {

      if (is_numeric($key)) {

        if ($value['match'] != 'exist' && !$value['phrase']) {

          unset($values['settings']['conditions'][$key]);

        }

      }

    }

    $google_keyhaviour = (object)array(

      'google_keyhaviour_id' => $values['google_keyhaviour_id'],

      'settings' => $values['settings'],

    );

    $google_keyhaviour = google_keyhaviour_save($google_keyhaviour);

    if (is_array($values['action'])) {

      foreach ($values['action'] as $google_keyhaviour_action_id => $value) {

        $google_keyhaviour_action = (object)array(

          'google_keyhaviour_action_id' => $google_keyhaviour_action_id,

          'weight' => $value['weight'],

        );

        $google_keyhaviour_action = google_keyhaviour_action_save($google_keyhaviour_action);

      }

    }

    drupal_set_message('The google keyhaviour rule was saved.');



    if ($form_state['clicked_button']['#id'] == 'edit-addaction') {

      $google_keyhaviour_action = (object)array(

        'google_keyhaviour_id' => $values['google_keyhaviour_id'],

      );

      $google_keyhaviour_action = google_keyhaviour_action_save($google_keyhaviour_action);

      $google_keyhaviour_action->title = t('Google keyhaviour action !1', array('!1' => $google_keyhaviour_action->google_keyhaviour_action_id));

      $google_keyhaviour_action = google_keyhaviour_action_save($google_keyhaviour_action);

      drupal_set_message('A google keyhaviour action was added.  Configure the action below.');

      drupal_goto('admin/build/google_keyhaviour/'. $values['google_keyhaviour_id'] .'/edit/'. $google_keyhaviour_action->google_keyhaviour_action_id .'/edit/');

    }

    else {

      drupal_goto('admin/build/google_keyhaviour/'. $values['google_keyhaviour_id'] .'/edit/');

    }

  }

}



/**

 * Admin google_keyhaviour delete page.

 */

function google_keyhaviour_admin_delete($form_state, $google_keyhaviour) {

  $form_state['storage']['google_keyhaviour'] = $google_keyhaviour;

  // build the form

  $form = array();

  $form['#tree'] = TRUE;

  $form['google_keyhaviour_id'] = array(

    '#type' => 'value',

    '#value' => $google_keyhaviour->google_keyhaviour_id,

  );

  return confirm_form($form,

    t('Are you sure you want to delete the %gkt google keyhaviour?', array('%gkt' => $google_keyhaviour->settings['title'])),

    $_GET['destination'] ? $_GET['destination'] : 'admin/build/google_keyhaviour',

    t('This action cannot be undone.'),

    t('Delete'), t('Cancel'));

}



/**

 * Submit function for admin google_keyhaviour delete page.

 */

function google_keyhaviour_admin_delete_submit($form, &$form_state) {

  $google_keyhaviour_id = &$form_state['values']['google_keyhaviour_id'];

  google_keyhaviour_delete($google_keyhaviour_id);

  menu_rebuild();

  drupal_goto('admin/build/google_keyhaviour');

}



/**

 * Admin google_keyhaviour action add/edit page.

 * Must have a google_keyhaviour object at this point.

 */

function google_keyhaviour_admin_action_edit($form_state, $google_keyhaviour, $google_keyhaviour_action_id) {

  $action = google_keyhaviour_admin_get_action_defaults($google_keyhaviour, $google_keyhaviour_action_id);

  $form_state['storage']['google_keyhaviour'] = $google_keyhaviour;

  $form_state['storage']['google_keyhaviour_action_id'] = $google_keyhaviour_action_id;

  $form_state['storage']['google_keyhaviour_action_defaults'] = $action;

  $settings = &$action->settings;



  $form = array();



  $form['#tree'] = TRUE;



  $form['google_keyhaviour_id'] = array(

    '#type' => 'value',

    '#value' => $google_keyhaviour->google_keyhaviour_id,

    '#weight' => 0,

  );



  $form['google_keyhaviour_action_id'] = array(

    '#type' => 'value',

    '#value' => $google_keyhaviour_action_id,

    '#weight' => 2,

  );



  $form['settings'] = array(

    '#weight' => 30,

  );



  $form['settings']['verb'] = array(

    '#type' => 'select',

    '#default_value' => $settings['verb'],

    '#options' => array(

      '' => '',

      'append' => t('Append'),

      'prepend' => t('Prepend'),

      'replace' => t('Replace'),

    ),

    '#weight' => '4',

    '#required' => TRUE,

  );



  $form['settings']['var'] = array(

    '#type' => 'select',

    '#default_value' => $settings['var'],

    '#options' => array('' => '') + google_keyhaviour_admin_list_variables(),

    '#weight' => '6',

    '#required' => TRUE,

  );



  $form['settings']['with'] = array(

    '#type' => 'textarea',

    '#title' => t('with'),

    '#default_value' => $settings['with'],

    '#required' => FALSE,

    '#rows' => 12,

    '#weight' => '8',

    '#description' => t('Use <i>&lt;keywords&gt;</i> to display the user\'s Google Keywords.'),

  );



  $form['submit'] = array(

    '#type' => 'submit',

    '#value' => t('Save google keyhaviour action'),

    '#weight' => 10000,

  );



  $form['delete'] = array(

    '#type' => 'submit',

    '#value' => t('Delete google keyhaviour action'),

    '#weight' => 10020,

  );



  return $form;

}



/**

 * Submit function for admin google_keyhaviour add/edit page.

 */

function google_keyhaviour_admin_action_edit_submit($form, &$form_state) {

  $values = &$form_state['values'];

  if ($form_state['clicked_button']['#id'] == 'edit-delete') {

    drupal_goto('admin/build/google_keyhaviour/'. $values['google_keyhaviour_id'] .'/edit/'. $values['google_keyhaviour_action_id'] .'/delete');

  }

  else {

    $google_keyhaviour_action = (object)array(

      'google_keyhaviour_action_id' => $values['google_keyhaviour_action_id'],

      'google_keyhaviour_id' => $values['google_keyhaviour_id'],

      'settings' => $values['settings'],

    );

    $google_keyhaviour_action = google_keyhaviour_action_save($google_keyhaviour_action);



    drupal_set_message('The google keyhaviour action was saved.');

    drupal_goto('admin/build/google_keyhaviour/'. $values['google_keyhaviour_id'] .'/edit');

  }

}



/**

 * Admin google_keyhaviour delete page

 */

function google_keyhaviour_admin_action_delete($form_state, $google_keyhaviour, $google_keyhaviour_action_id) {

  $action = google_keyhaviour_admin_get_action_defaults($google_keyhaviour, $google_keyhaviour_action_id);



  $form = array();

  $form['#tree'] = TRUE;

  $form['google_keyhaviour_action_id'] = array(

    '#type' => 'value',

    '#value' => $google_keyhaviour_action_id,

  );

  $form['google_keyhaviour_id'] = array(

    '#type' => 'value',

    '#value' => $google_keyhaviour->google_keyhaviour_id,

  );

  return confirm_form($form,

    t('Are you sure you want to delete the google keyhaviour action?'),

    $_GET['destination'] ? $_GET['destination'] : 'admin/build/google_keyhaviour/'. $google_keyhaviour->google_keyhaviour_id .'/edit',

    t('This action cannot be undone.'),

    t('Delete'), t('Cancel'));

}



/**

 * Submit function for admin google_keyhaviour delete page.

 */

function google_keyhaviour_admin_action_delete_submit($form, &$form_state) {

  $google_keyhaviour_action_id = &$form_state['values']['google_keyhaviour_action_id'];

  $google_keyhaviour_id = &$form_state['values']['google_keyhaviour_id'];

  google_keyhaviour_action_delete($google_keyhaviour_action_id);

  drupal_goto('admin/build/google_keyhaviour/'. $google_keyhaviour_id .'/edit');

}



/**

 * Default settings for an action.

 */

function google_keyhaviour_admin_get_action_defaults($google_keyhaviour, $google_keyhaviour_action_id) {

  // because we are not keying by $google_keyhaviour_action_id, we have to find the correct action like this.

  $key = $google_keyhaviour->actions_index[$google_keyhaviour_action_id];

  return $google_keyhaviour->actions[$key];

}



/**

 * Get a list of variables for admin selection.

 */

function google_keyhaviour_admin_list_variables($variable = NULL) {

  static $list = array();

  if (empty($list)) {

    $variables = array(

      'base_path',

      'body_classes',

      'breadcrumb',

      'closure',

      'content',

      'db_is_active',

      'directory',

      'feed_icons',

      'footer',

      'footer_message',

      'front_page',

      'head',

      'head_title',

      'header',

      'help',

      'id',

      'is_admin',

      'is_front',

      'layout',

      'left',

      'logged_in',

      'logo',

      'messages',

      'mission',

      'right',

      'scripts',

      'search_box',

      'show_blocks',

      'show_messages',

      'site_name',

      'site_slogan',

      'styles',

      'tabs',

      'title',

      'zebra',

    );

    foreach ($variables as $var) {

      $list[$var] = '$'. $var;

    }

  }

  if ($variable) {

    return $list[$variable];

  }

  return $list;

  /*

  To do;

  shall we handle these objects and arrays?

    * template_files

    * user

    * language

    * primary_links

    * secondary_links

    * css

  */

}